VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Calculator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim CallController As CallController

Private Enum CalculatorStates
    csWelcome = 0
    csFirstOperand = 1
    csSecondOperand = 2
    csResult = 3
    csError = 9
End Enum

Dim FirstOperand As String
Dim SecondOperand As String

Dim CalculatorState As CalculatorStates

Implements ITVCallHandler

Private Sub Class_Initialize()

End Sub

Private Sub Class_Terminate()
    Set CallController = Nothing
End Sub

Private Sub ITVCallHandler_Init(objCallController As TERAVoiceLib.CallController)
    Set CallController = objCallController
End Sub

Private Sub ITVCallHandler_DigitReceived(Digit As String)

    Select Case CalculatorState
    Case csWelcome, csFirstOperand
        Select Case Digit
        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
            FirstOperand = FirstOperand & Digit
            CalculatorState = csFirstOperand
            CallController.StopPlayRecord
        Case "*"
            If FirstOperand = "" Then
                'At least one digit is needed for first operand
                CallController.StopPlayRecord
                CalculatorState = csError
            Else
                'Now wait for input of second operand
                CalculatorState = csSecondOperand
            End If
        Case Else
            'A wrong digit was entered
            CalculatorState = csError
            CallController.StopPlayRecord
        End Select
    Case csSecondOperand
        Select Case Digit
        Case "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
            SecondOperand = SecondOperand & Digit
        Case "#"
            If SecondOperand = "" Then
                'At least one digit is needed for second operand
                CallController.StopPlayRecord
                CalculatorState = csError
            Else
                'Now calculate and output result
                CalculatorState = csResult
            End If
        Case Else
            'A wrong digit was entered
            CalculatorState = csError
            CallController.StopPlayRecord
        End Select
    Case Else
        'Ignore this digit in all other states
    End Select
        
End Sub

Private Sub ITVCallHandler_FileSaved(FileName As String, Length As Long)
    'This procedure is not needed in this sample
    'All procedures of ITVCallHandler must be implemented though!
End Sub

Private Sub ITVCallHandler_PlayDone()

    Select Case CalculatorState
    Case csWelcome
        CalculatorState = csFirstOperand
    Case csResult
        CalculatorState = csWelcome
    Case csError
        CalculatorState = csWelcome
    End Select

End Sub

Private Sub ITVCallHandler_TimePulse()
Dim Result As String
Dim FileArray() As String
Dim i As Long

    Select Case CalculatorState
    Case csWelcome
        If Not CallController.IsPlaying Then
            If Not CallController.PlayAudioFile(App.Path & "\Welcome.wav") Then
                CallController.WriteLogFile 10, "Unable to play audio file", True
                CallController.HangUp
            End If
        End If
    Case csResult
        If Not CallController.IsPlaying Then
            Result = CStr(Val(FirstOperand) + Val(SecondOperand))
            FirstOperand = ""
            SecondOperand = ""
            ReDim FileArray(Len(Result))
            FileArray(0) = App.Path & "\TheResultIs.wav"
            For i = 1 To Len(Result)
                FileArray(i) = App.Path & "\" & Mid(Result, i, 1) & "A.wav"
            Next
            If Not CallController.PlayAudioFileList(FileArray()) Then
                CallController.WriteLogFile 12, "Unable to play audio file list", True
                CallController.HangUp
            End If
        End If
    Case csError
        If Not CallController.IsPlaying Then
            If Not CallController.PlayAudioFile(App.Path & "\Error.wav") Then
                CallController.WriteLogFile 14, "Unable to play audio file", True
                CallController.HangUp
            End If
        End If
    End Select


    
End Sub

Private Sub ITVCallHandler_UnInit()

    'Important: Do not forget to destroy this object!!!
    Set CallController = Nothing
    
    'Also do not forget to destroy object references,
    'otherwise this object might never get unloaded
    
End Sub
