// Calculator.h : Declaration of the CCalculator

#ifndef __CALCULATOR_H_
#define __CALCULATOR_H_

#import "F:\Projects\TERAVoice\Server\TERAVoiceLib\TERAVoiceLib.dll" raw_interfaces_only, raw_native_types, no_namespace, named_guids 
#include "resource.h"       // main symbols
#pragma warning(disable:4786)
#include <string>
#include <iostream>
#include <sstream>

using namespace std;

const int csWelcome = 0;
const int csFirstOperand = 1;
const int csSecondOperand = 2;
const int csResult = 3;
const int csError = 9;

/////////////////////////////////////////////////////////////////////////////
// CCalculator
class ATL_NO_VTABLE CCalculator : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCalculator, &CLSID_Calculator>,
	public IDispatchImpl<ICalculator, &IID_ICalculator, &LIBID_TVC6SAMPLE1Lib>,
	public IDispatchImpl<_ITVCallHandler, &IID__ITVCallHandler, &LIBID_TERAVoiceLib>
{
public:
	CCalculator()
	{ 
		CalculatorState = csWelcome;
		FirstOperand = L"";
		SecondOperand = L"";
		BasePath = L"F:\\Projects\\TERAvoice\\Server\\Samples\\Visual Basic 6\\Calculator";
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CALCULATOR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCalculator)
	COM_INTERFACE_ENTRY(ICalculator)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY2(IDispatch, ICalculator)
	COM_INTERFACE_ENTRY(_ITVCallHandler)
END_COM_MAP()

// ICalculator
public:
// _ITVCallHandler
	STDMETHOD(Init)(_CallController * * objCallController)
	{
		if (objCallController == NULL)
			return E_POINTER;
			
		return m_Init(objCallController);
	}
	STDMETHOD(UnInit)()
	{
		return m_UnInit();
	}
	STDMETHOD(DigitReceived)(BSTR * Digit)
	{
		if (Digit == NULL)
			return E_POINTER;
			
		return m_DigitReceived(Digit);
	}
	STDMETHOD(TimePulse)()
	{
		return m_TimePulse();
	}
	STDMETHOD(FileSaved)(BSTR * FileName, LONG * Length)
	{
		if (FileName == NULL)
			return E_POINTER;
			
		if (Length == NULL)
			return E_POINTER;
			
		return S_OK;
	}
	STDMETHOD(PlayDone)()
	{
		return m_PlayDone();
	}
private:
	long m_TimePulse();
	long m_PlayDone();
	int CalculatorState;
	wstring FirstOperand;
	wstring SecondOperand;
	wstring BasePath;
	long m_UnInit();
	long m_Init(_CallController * * objCallController);
	long m_DigitReceived(BSTR * Digit);
	_CallController * myCallController;
};

#endif //__CALCULATOR_H_
